--++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-- Register Bank (R0..R31) - 31 GENERAL PURPOSE 16-bit REGISTERS
--++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
library IEEE;
use IEEE.Std_Logic_1164.all;
use IEEE.STD_LOGIC_UNSIGNED.all;
use work.p_MR4.all;

entity reg_bank is
	port
	(
		ck, rst, wreg:    in std_logic;
		AdRs, AdRt, adRD: in std_logic_vector(4 downto 0);
		RD: in reg32;
		R1, R2: out reg32
	);
end reg_bank;

architecture reg_bank of reg_bank is

	type bank is array(0 to 31) of reg32;
	signal reg: bank ;
	signal wen: reg32 ;
	signal address1, address2: std_logic_vector( 4 downto 0) ;

begin

	address1 <= adRD when wreg = '1' else AdRt; -- definio do endereo da primeira porta
	address2 <= adRD when wreg = '1' else AdRs; -- definio do endereo da primeira porta

--	banco: for i in 0 to 31 generate
--		M1: RAM32X1S port map
--		(
--			WCLK=>ck,
--			WE=>wreg,
--			D=>RD(i),
--			A0=>address1(0),
--			A1=>address1(1),
--			A2=>address1(2),
--			A3=>address1(3),
--			A4=>address1(4),
--			O => R2(i)
--		);
--		
--		M2: RAM32X1S port map
--		(
--			WCLK=>ck,
--			WE=>wreg,
--			D=>RD(i),
--			A0=>address2(0),
--			A1=>address2(1),
--			A2=>address2(2),
--			A3=>address2(3),
--			A4=>address2(4),
--			O => R1(i)
--		);
--	end generate banco;

	l1: for i in 0 to 31 generate
		wen(i) <= '1' when i /= 0 and adRD = i and wreg = '1' else '0';
		rx: entity work.regnbit port map(ck => ck, rst => rst, ce => wen(i), D => RD, Q => reg(i));
	end generate l1;

	R1 <= reg(CONV_INTEGER(AdRs));    -- source1 selection

	R2 <= reg(CONV_INTEGER(AdRt));    -- source2 selection

end reg_bank;