--++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-- register
--++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
library IEEE;
use IEEE.std_logic_1164.all;

entity regnbit is
	generic(INIT_VALUE : STD_LOGIC_VECTOR(31 downto 0) := (others=>'0'));
	port
	(
		ck, rst, ce : in std_logic;
		D: in  STD_LOGIC_VECTOR(31 downto 0);
		Q: out STD_LOGIC_VECTOR(31 downto 0)
	);
end regnbit;

architecture regn of regnbit is
begin

	process(ck, rst)
	begin
		if rst = '1' then
			Q <= INIT_VALUE(31 downto 0);
		elsif ck'event and ck = '0' then
			if ce = '1' then
				Q <= D;
			end if;
		end if;
	end process;

end regn;